/*!
	Document:      canvas_view.js
	Date started:  22 Aug 2011
	By:            Matt Fozard
	Purpose:       Quru Image Server HTML 5 viewer client
	Requires:      common_view.js
	Copyright:     Quru Ltd (www.quru.com)
	Licence:

	This program is free software: you can redistribute it and/or modify
	it under the terms of the GNU Affero General Public License as published
	by the Free Software Foundation, either version 3 of the License, or
	(at your option) any later version.

	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU Affero General Public License for more details.

	You should have received a copy of the GNU Affero General Public License
	along with this program.  If not, see http://www.gnu.org/licenses/
*/
Math.parseInt=function(b,a){if(!b||!(/^[-]*[\d]+$/.test(b))){return a;
}else{return parseInt(b,10);}};Math.parseFloat=function(b,a){if(!b||!(/^[-]*[.|\d]+$/.test(b))){return a;
}else{return parseFloat(b);}};Math.round1=function(a){return Math.round(a*10)/10;};Math.round8=function(a){return Math.round(a*Math.pow(10,8))/Math.pow(10,8);
};Math.limit=function(b,c,a){return Math.min(Math.max(b,c),a);};Math.roundToMultiple=function(b,a,d){var c=b%a;
if(c!=0){if((c<(a/2))||d){c=-c;}else{c=(a-c);}}return Math.round(b+c);};Math.linearTween=function(e,a,g,f){return g*e/f+a;
};Math.easeOutQuad=function(e,a,g,f){return -g*(e/=f)*(e-2)+a;};Math.easeInOutQuad=function(e,a,g,f){if((e/=f/2)<1){return g/2*e*e+a;
}return -g/2*((--e)*(e-2)-1)+a;};Math.easeOutSine=function(e,a,g,f){return g*Math.sin(e/f*(Math.PI/2))+a;
};Math.easeInOutSine=function(e,a,g,f){return -g/2*(Math.cos(Math.PI*e/f)-1)+a;};Math.easeOutBack=function(e,a,h,g,f){if(f==undefined){f=1.70158;
}return h*((e=e/g-1)*e*((f+1)*e+f)+1)+a;};Math.easeInOutBack=function(e,a,h,g,f){if(f==undefined){f=1.70158;
}if((e/=g/2)<1){return h/2*(e*e*(((f*=(1.525))+1)*e-f))+a;}return h/2*((e-=2)*e*(((f*=(1.525))+1)*e+f)+2)+a;
};function ImgGrid(c,i,e,j,d,b,g,h){this.initialised=false;this.destroyed=false;this.onInitialisedFn=h;
this.animating=false;this.g2d={ctx:d,origin:{x:0,y:0}};var f=Math.linearTween;switch(b.toLowerCase()){case"in-out-back":f=Math.easeInOutBack;
break;case"in-out-quadratic":f=Math.easeInOutQuad;break;case"in-out-sine":f=Math.easeInOutSine;break;
case"out-back":f=Math.easeOutBack;break;case"out-quadratic":f=Math.easeOutQuad;break;case"out-sine":f=Math.easeOutSine;
break;}if(window.requestAnimationFrame){this.animate=function(k){window.requestAnimationFrame(k);};}else{this.animate=function(k){return setTimeout(k,17);
};}this.zoom={level:1,nextLevel:1,maxLevel:10,drawZoom:{x:1,y:1},animateFn:f};this.gridOpts={maxTiles:g,maxWidth:0,maxHeight:0,minWidth:0,minHeight:0,aspect:1,showGrid:false};
this.viewport={origWidth:c,origHeight:i,origAspect:c/i,width:c,height:i,aspect:c/i};this.grids=new Array();
this.grid=null;this.requests={queue:new Array(),active:0,limit:2,enforceLimit:true,requested:0,showProgress:false};
var a=QU.splitURL(e);this.urlParams=QU.QueryStringToObject(a.query,false);if(j){delete this.urlParams.halign;
delete this.urlParams.valign;}this.urlBase=a.protocol+a.server;this.urlCommand=a.path;this.loadingText="Loading image...";
this.drawText(this.loadingText);this.loadImageInfo();}ImgGrid.prototype.destroy=function(){this.initialised=false;
this.destroyed=true;this.cancelPendingImages();this.g2d.ctx=null;};ImgGrid.prototype.reset=function(){if(!this.initialised||this.destroyed){return;
}this.animating=false;this.cancelPendingImages();this.g2d.ctx.translate(-this.g2d.origin.x,-this.g2d.origin.y);
this.g2d.origin.x=this.g2d.origin.y=0;this.zoom.level=this.zoom.nextLevel=1;this.zoom.drawZoom.x=this.zoom.drawZoom.y=1;
this.setGrid(1,true);};ImgGrid.prototype.setViewportSize=function(b,a){this.viewport.width=b;this.viewport.height=a;
this.viewport.aspect=b/a;this.g2d.ctx.translate(this.g2d.origin.x,this.g2d.origin.y);if(this.initialised){this.centreGrid(true,true,false);
this.setGrid(this.zoom.level,true);this.cancelPendingHiddenImages();}else{if(!this.destroyed){this.drawText(this.loadingText);
if(this.grids.length>0){this.centreGrid(true,true,false);this.setGrid(this.zoom.level,false);}}}};ImgGrid.prototype.loadImageInfo=function(){var a=this.urlBase+"/api/v1/details/?src="+encodeURIComponent(this.urlParams.src);
QU.jsonRequest(a,"GET",function(c,b){this.onImageInfoLoaded(b);}.bind(this),function(c,b){this.onImageInfoFailure(c);
}.bind(this)).send();};ImgGrid.prototype.onImageInfoLoaded=function(i){if(this.destroyed){return;}if((i.status>=300)||(i.data.width<=0)||(i.data.height<=0)){this.onImageInfoFailure(null);
}else{var g=i.data.width,f=i.data.height;if(this.urlParams.angle){var d=Math.abs(Math.parseFloat(this.urlParams.angle,0));
if((d==90)||(d==270)){var b=g;g=f;f=b;}}if(this.urlParams.top||this.urlParams.left||this.urlParams.right||this.urlParams.bottom){var e=Math.limit(Math.parseFloat(this.urlParams.top,0),0,1),c=Math.limit(Math.parseFloat(this.urlParams.left,0),0,1),h=Math.limit(Math.parseFloat(this.urlParams.right,1),0,1),a=Math.limit(Math.parseFloat(this.urlParams.bottom,1),0,1);
if((e<a)&&(c<h)){g=Math.round(g*(h-c));f=Math.round(f*(a-e));}}this.imageInfo=i.data;this.initialise(g,f);
}};ImgGrid.prototype.onImageInfoFailure=function(a){if(!this.destroyed){this.drawText("X");}};ImgGrid.prototype.initialise=function(d,c){this.gridOpts.maxWidth=d;
this.gridOpts.maxHeight=c;this.gridOpts.aspect=d/c;if(this.gridOpts.aspect>=this.viewport.origAspect){this.gridOpts.minWidth=Math.min(d,this.viewport.origWidth);
this.gridOpts.minHeight=Math.round(this.gridOpts.minWidth/this.gridOpts.aspect);}else{this.gridOpts.minHeight=Math.min(c,this.viewport.origHeight);
this.gridOpts.minWidth=Math.round(this.gridOpts.minHeight*this.gridOpts.aspect);}for(var b=1;b<=this.zoom.maxLevel;
b++){var a=this.calcGridSize(b);var e=this.calcGridTiles(a.width,a.height,a.length);this.grids[b]={images:[],grid:e,length:a.length,axis:a.axis,origWidth:a.width,origHeight:a.height,width:a.width,height:a.height};
if(a.max){this.zoom.maxLevel=b;break;}}this.setGrid(1,false);this.requestImage(1,1);};ImgGrid.prototype.closestRatioMultiples=function(b,m,n,j,h){var d=Math.roundToMultiple(b,h),l=Math.roundToMultiple(Math.round(d/j),h),a=Math.round8(j);
if((Math.round8(d/l)==a)&&(d>=m)&&(d<=n)){return{a:d,b:l};}else{var g=Math.roundToMultiple(m,h),f=Math.roundToMultiple(n,h),i=new Array();
if(g<m){g+=h;}if(f>n){f-=h;}for(var c=d+h;c<=f;c+=h){var k=Math.roundToMultiple(Math.round(c/j),h),e=c/k;
if(Math.round8(e)==a){return{a:c,b:k};}else{i.push({a:c,b:k,diff:Math.abs(j-e)});}}for(var c=d-h;c>=g;
c-=h){var k=Math.roundToMultiple(Math.round(c/j),h),e=c/k;if(Math.round8(e)==a){return{a:c,b:k};}else{i.push({a:c,b:k,diff:Math.abs(j-e)});
}}if(i.length==0){return{a:d,b:l};}else{i.sort(function(p,o){return p.diff-o.diff;});return i[0];}}};
ImgGrid.prototype.calcGridSize=function(e){var h=[[500,1],[960,1],[1728,16],[3120,64],[5600,64],[10240,256],[18432,1024],[33024,1024],[59392,4096],[107008,16384]];
if(e==1){var b=this.gridOpts.minWidth,q=this.gridOpts.minHeight,p=1,m=1,l=(Math.max(b,q)>=h[h.length-1][0])||(b>=this.gridOpts.maxWidth)||(q>=this.gridOpts.maxHeight);
}else{var c=(this.gridOpts.aspect>=this.viewport.origAspect)?this.gridOpts.minWidth:this.gridOpts.minHeight,j=0;
for(var g=0;g<h.length;g++){if(h[g][0]>=c){j=g;break;}}var f=Math.min(j+e-1,h.length-1);if(this.gridOpts.aspect>=1){var b=h[f][0],q=Math.round(b/this.gridOpts.aspect);
}else{var q=h[f][0],b=Math.round(q*this.gridOpts.aspect);}var p=Math.min(h[f][1],this.gridOpts.maxTiles),m=Math.round(Math.sqrt(p)),l=(f==(h.length-1));
if(((b/this.gridOpts.maxWidth)>0.85)||((q/this.gridOpts.maxHeight)>0.85)){b=this.gridOpts.maxWidth;q=this.gridOpts.maxHeight;
l=true;}if(p>1){var d=Math.max(m,4),o=10,a=Math.max(this.gridOpts.minWidth,b-(o*d)),n=Math.min(this.gridOpts.maxWidth,b+(o*d));
var k=this.closestRatioMultiples(b,a,n,this.gridOpts.aspect,d);b=k.a;q=k.b;}}return{width:b,height:q,length:p,axis:m,max:l};
};ImgGrid.prototype.calcGridTiles=function(b,o,d){var j=new Array();if(d==1){j[1]={tile:1,x1:0,y1:0,x2:(b-1),y2:(o-1),width:b,height:o};
}else{var c=Math.round(Math.sqrt(d));var p=Math.floor(b/c),n=Math.floor(o/c),m=b%c,k=o%c;for(var g=1;
g<=d;g++){var l=this.tileToXY(g,c);var f=l.x*p,e=l.y*n;var h=(l.x==(c-1))?(p+m):p,a=(l.y==(c-1))?(n+k):n;
j[g]={tile:g,x1:f,y1:e,x2:(f+h-1),y2:(e+a-1),width:h,height:a};}}return j;};ImgGrid.prototype.setGrid=function(b,a){this.grid=this.grids[b];
this.grid.width=this.grid.origWidth;this.grid.height=this.grid.origHeight;var c=this.fillsViewport(this.grid);
this.centreGrid(!c.x,!c.y,false);this.alignGrid(false);if(a){this.paint();}};ImgGrid.prototype.getVisibleGridTiles=function(){var c=new Array();
if(this.grid.length==1){c[0]=1;}else{var e=-this.g2d.origin.x,h=-this.g2d.origin.y,b=e+this.viewport.width-1,g=h+this.viewport.height-1;
for(var d=1;d<=this.grid.length;d++){var f=this.grid.grid[d];var a=((f.x1*this.zoom.drawZoom.x)>b||(f.x2*this.zoom.drawZoom.x)<e||(f.y1*this.zoom.drawZoom.y)>g||(f.y2*this.zoom.drawZoom.y)<h);
if(!a){c[c.length]=d;}}}return c;};ImgGrid.prototype.tileToXY=function(d,b){var f=Math.floor(d/b),e=d%b,a=(e!=0)?(e-1):(b-1),c=(e!=0)?f:(f-1);
return{x:a,y:c};};ImgGrid.prototype.xyToTile=function(a,c,b){return(c*b)+a+1;};ImgGrid.prototype.getFallbackTile=function(b,d){var u=this.zoom.level,c=u;
var a=this.tileToXY(b,this.grid.axis),s=d.x1/this.grid.origWidth,r=d.y1/this.grid.origHeight,t=d.width/this.grid.origWidth,e=d.height/this.grid.origHeight;
while(--c>=1){var m=this.grids[c],q=Math.round(this.grid.axis/m.axis),k=Math.floor(a.x/q),h=Math.floor(a.y/q),n=this.xyToTile(k,h,m.axis),o=m.images[n];
if((o!=undefined)&&o._loaded){var v=m.grid[n],j=v.x1/m.origWidth,g=v.y1/m.origHeight;var i=Math.limit(Math.round((s-j)*m.origWidth),0,o.width-1),f=Math.limit(Math.round((r-g)*m.origHeight),0,o.height-1),l=Math.limit(Math.round(t*m.origWidth),1,o.width-i),p=Math.limit(Math.round(e*m.origHeight),1,o.height-f);
return{img:o,srcx:i,srcy:f,srcw:l,srch:p};}}};ImgGrid.prototype.getImageURL=function(a,b){this.urlParams.format="jpg";
this.urlParams.autosizefit="0";this.urlParams.strip="1";this.urlParams.stats=(a>1)?"0":"1";this.urlParams.width=this.grids[a].origWidth;
this.urlParams.height=this.grids[a].origHeight;if(this.grids[a].length>1){this.urlParams.tile=b+":"+this.grids[a].length;
}else{delete this.urlParams.tile;}return this.urlBase+this.urlCommand+"?"+QU.ObjectToQueryString(this.urlParams);
};ImgGrid.prototype.getBestFitLevel=function(){if(!this.initialised){return 1;}var c=new Array();for(var b=1;
b<=this.zoom.maxLevel;b++){var a=Math.abs(this.viewport.width-this.grids[b].origWidth),e=Math.abs(this.viewport.height-this.grids[b].origHeight),d=a+e;
c.push({level:b,diff:d});}c.sort(function(g,f){return g.diff-f.diff;});return c[0].level;};ImgGrid.prototype.requestImage=function(c,d){if(this.grids[c].images[d]!=undefined){return;
}for(var b,a=0;a<this.requests.queue.length;a++){b=this.requests.queue[a];if((b.zLevel==c)&&(b.tileNo==d)){return;
}}this.requests.queue.push({zLevel:c,tileNo:d,url:this.getImageURL(c,d),onLoad:function(){this.requests.active=Math.max(this.requests.active-1,0);
this.onImageLoaded(c,d);this.pollImageQueue();}.bind(this),onAbort:function(){this.requests.active=Math.max(this.requests.active-1,0);
this.pollImageQueue();}.bind(this),onError:function(){this.requests.active=Math.max(this.requests.active-1,0);
this.pollImageQueue();}.bind(this)});this.requests.requested++;if(this.requests.requested==1){setTimeout(function(){if(this.requests.requested>0){this.requests.showProgress=true;
this.paint();}}.bind(this),500);}this.pollImageQueue();};ImgGrid.prototype.pollImageQueue=function(){while((this.requests.queue.length>0)&&(this.requests.active<this.requests.limit)){this.requests.active++;
var a=this.requests.queue.splice(0,1)[0];var b=document.createElement("img");b.onload=a.onLoad;b.onabort=a.onAbort;
b.onerror=a.onError;b.src=a.url;this.grids[a.zLevel].images[a.tileNo]=b;}if((this.requests.queue.length==0)&&(this.requests.active==0)){this.requests.requested=0;
this.requests.showProgress=false;this.paint();}};ImgGrid.prototype.onImageLoaded=function(a,c){var b=this.grids[a].images[c];
b._loaded=true;if(!this.initialised&&(a==1)){this.initialised=true;if(this.onInitialisedFn){setTimeout(function(){this.onInitialisedFn(this.imageInfo);
}.bind(this),1);}}if((a==this.zoom.level)&&!this.animating){this.paint();}};ImgGrid.prototype.cancelPendingHiddenImages=function(){var a=this.getVisibleGridTiles();
for(var b=0;b<this.requests.queue.length;b++){var c=this.requests.queue[b];if((c.zLevel!=this.zoom.level)||(a.indexOf(c.tileNo)===-1)){this.requests.queue.splice(b,1);
this.requests.requested--;b--;}}};ImgGrid.prototype.cancelPendingImages=function(){this.requests.queue.length=0;
if(!this.requests.enforceLimit){this.requests.active=0;}};ImgGrid.prototype.fillsViewport=function(a){return{x:(a.width>=this.viewport.width),y:(a.height>=this.viewport.height)};
};ImgGrid.prototype.centreGrid=function(d,f,c){var a=(this.viewport.width-this.grid.width)/2,g=(this.viewport.height-this.grid.height)/2;
var e=d?(a-this.g2d.origin.x):0,b=f?(g-this.g2d.origin.y):0;if((e!=0)||(b!=0)){this.g2d.ctx.translate(e,b);
this.g2d.origin.x+=e;this.g2d.origin.y+=b;}if(c){this.paint();}};ImgGrid.prototype.panGrid=function(c,b,a,d){if(!this.initialised){return false;
}if(a||d){if(a&&(this.grid.width>=this.viewport.width)){if(this.g2d.origin.x+c>0){c=-this.g2d.origin.x;
}else{if(this.g2d.origin.x+this.grid.width+c<this.viewport.width){c=-((this.grid.width-this.viewport.width)+this.g2d.origin.x);
}}}else{c=0;}if(d&&(this.grid.height>=this.viewport.height)){if(this.g2d.origin.y+b>0){b=-this.g2d.origin.y;
}else{if(this.g2d.origin.y+this.grid.height+b<this.viewport.height){b=-((this.grid.height-this.viewport.height)+this.g2d.origin.y);
}}}else{b=0;}}if((c!=0)||(b!=0)){this.g2d.ctx.translate(c,b);this.g2d.origin.x+=c;this.g2d.origin.y+=b;
this.paint();return true;}return false;};ImgGrid.prototype.autoPanGrid=function(b,a){if(!this.initialised||this.animating){return;
}if((this.grid.width<=this.viewport.width)&&(this.grid.height<=this.viewport.height)){return;}var c=this.fillsViewport(this.grid);
if(!c.x){b=0;}if(!c.y){a=0;}this.animating=true;this.animate(function(){this.animatePan(1,20,b,a,Math.easeOutQuad);
}.bind(this));};ImgGrid.prototype.alignGrid=function(b){var c=this.g2d.origin.x-Math.round(this.g2d.origin.x),a=this.g2d.origin.y-Math.round(this.g2d.origin.y);
if((c!=0)||(a!=0)){this.g2d.ctx.translate(-c,-a);this.g2d.origin.x=Math.round(this.g2d.origin.x);this.g2d.origin.y=Math.round(this.g2d.origin.y);
}if(b){this.paint();}};ImgGrid.prototype.zoomFit=function(){if(!this.initialised||this.animating){return;
}var a=this.getBestFitLevel(),b=a-this.zoom.level;if(b!=0){this.zoomGrid(b,{x:0.5,y:0.5});}};ImgGrid.prototype.zoomGrid=function(d,c){if(!this.initialised||this.animating){return;
}var a=Math.limit(this.zoom.level+d,1,this.zoom.maxLevel);if(a!=this.zoom.level){this.cancelPendingImages();
this.zoom.nextLevel=a;var b={width:this.grids[a].origWidth,height:this.grids[a].origHeight};this.animating=true;
this.animate(function(){this.animateZoom(1,20,this.grid.width,this.grid.height,b.width-this.grid.width,b.height-this.grid.height,(b.width/b.height)-(this.grid.width/this.grid.height),c,this.zoom.animateFn);
}.bind(this));}};ImgGrid.prototype.animateZoom=function(i,f,j,k,p,b,a,o,l){if(!this.animating){return;
}var m=this.grid.width,g=this.grid.height,e=l(i,j,p,f),n=l(i,k,b,f),h=e-m,q=n-g;this.grid.width=e;this.grid.height=n;
this.zoom.drawZoom.x=e/j;this.zoom.drawZoom.y=n/k;var r=this.fillsViewport(this.grid);if(!r.x&&!r.y){this.centreGrid(true,true);
this.paint();}else{if(!r.x||!r.y){var d=r.x?-(h*o.x):0,c=r.y?-(q*o.y):0;this.centreGrid(!r.x,!r.y);if(!this.panGrid(d,c,r.x,r.y)){this.paint();
}}else{if(!this.panGrid(-(h*o.x),-(q*o.y),true,true)){this.paint();}}}if(++i<=f){this.animate(function(){this.animateZoom(i,f,j,k,p,b,a,o,l);
}.bind(this));return;}this.onAnimateZoomComplete();};ImgGrid.prototype.onAnimateZoomComplete=function(){this.animating=false;
this.zoom.level=this.zoom.nextLevel;this.zoom.drawZoom.x=this.zoom.drawZoom.y=1;this.setGrid(this.zoom.level,true);
this.cancelPendingHiddenImages();};ImgGrid.prototype.animatePan=function(g,f,d,b,e){if(!this.animating){return;
}var c=e(g,0,d,f),a=e(g,0,b,f);if(this.panGrid(d-c,b-a,true,true)){if(++g<=f){this.animate(function(){this.animatePan(g,f,d,b,e);
}.bind(this));return;}}this.onAnimatePanComplete();};ImgGrid.prototype.onAnimatePanComplete=function(){this.animating=false;
this.alignGrid(true);this.cancelPendingHiddenImages();};ImgGrid.prototype.drawText=function(c){var b=Math.min(28,(this.viewport.width/c.length)*0.66);
var a=this.g2d.ctx;a.save();a.font=b+"pt Arial";a.fillStyle="#aaaaaa";a.textAlign="center";a.textBaseline="middle";
this.clear();a.fillText(c,this.viewport.width/2,this.viewport.height/2);a.restore();};ImgGrid.prototype.clear=function(){if(this.g2d.ctx){this.g2d.ctx.clearRect(-this.g2d.origin.x,-this.g2d.origin.y,this.viewport.width,this.viewport.height);
}};ImgGrid.prototype.paint=function(){if(!this.initialised){return;}var d=[],b=0,a=this.getVisibleGridTiles(),g=this.fillsViewport(this.grid);
if(!g.x||!g.y){this.clear();}for(b=0;b<a.length;b++){var c=this.grid.grid[a[b]],f=this.grid.images[a[b]],e=(this.zoom.drawZoom.x<1?0.5:0);
if((f!=undefined)&&f._loaded){this.g2d.ctx.drawImage(f,c.x1*this.zoom.drawZoom.x,c.y1*this.zoom.drawZoom.y,c.width*this.zoom.drawZoom.x+e,c.height*this.zoom.drawZoom.y+e);
}else{if(f==undefined){d[d.length]=a[b];}f=this.getFallbackTile(a[b],c);this.g2d.ctx.drawImage(f.img,f.srcx,f.srcy,f.srcw,f.srch,c.x1*this.zoom.drawZoom.x,c.y1*this.zoom.drawZoom.y,c.width*this.zoom.drawZoom.x+e,c.height*this.zoom.drawZoom.y+e);
}}if((d.length>0)&&(this.zoom.level==this.zoom.nextLevel)){for(b=0;b<d.length;b++){this.requestImage(this.zoom.level,d[b]);
}}if(this.gridOpts.showGrid){this.paintgrid();}if((this.requests.requested>0)&&this.requests.showProgress){this.paintprogress();
}};ImgGrid.prototype.paintprogress=function(){var f=this.requests.queue.length+this.requests.active,d=(this.requests.requested-f)/this.requests.requested,e=Math.limit(this.viewport.width/2,100,300),c=((this.viewport.width-e)/2)-this.g2d.origin.x,b=(this.viewport.height-15)-this.g2d.origin.y,a=this.g2d.ctx;
a.save();a.lineWidth=10;a.lineCap="round";a.beginPath();a.moveTo(c,b);a.strokeStyle="rgba(0,0,0,0.5)";
a.lineTo(c+e,b);a.stroke();if(d>0){a.beginPath();a.moveTo(c,b);a.strokeStyle="rgba(255,255,255,0.7)";
a.lineTo(c+(e*d),b);a.stroke();}a.restore();};ImgGrid.prototype.paintgrid=function(){var a=this.g2d.ctx;
a.save();a.strokeStyle="#ff0000";a.fillStyle="#ff0000";a.font=((this.grid.width/10)/(this.grid.axis/2))+"pt Arial";
a.textAlign="center";a.textBaseline="middle";for(var b=1;b<=this.grid.length;b++){var c=this.grid.grid[b];
a.beginPath();a.moveTo(c.x1*this.zoom.drawZoom.x,c.y2*this.zoom.drawZoom.y);a.lineTo(c.x2*this.zoom.drawZoom.x,c.y2*this.zoom.drawZoom.y);
a.lineTo(c.x2*this.zoom.drawZoom.x,c.y1*this.zoom.drawZoom.y);a.stroke();a.fillText(""+b,(c.x1*this.zoom.drawZoom.x)+(c.width*this.zoom.drawZoom.x/2),(c.y1*this.zoom.drawZoom.y)+(c.height*this.zoom.drawZoom.y/2));
}a.restore();};function ImgCanvasView(a,c,d,b){this.options={title:null,description:null,showcontrols:"auto",quality:true,animation:"out-quadratic",maxtiles:256,stripaligns:false,doubleclickreset:true,controls:{download:false,title:true,help:true,reset:true,fullscreen:true,zoomin:true,zoomout:true},fullScreenFixed:true,fullScreenCloseOnClick:true};
if(d){this.options=QU.merge(this.options,d);}this.events=b;this._events={};this.uiAttrs={alertVisible:false,alertEl:null,fullScreen:false,fullMaskEl:null,fullSwapEl:null,fullCloseEl:null,fullKeydownFn:null,fullResizeFn:null,animating:false};
this.mouseAttrs={down:false,dragged:false,downTime:0,down_x:0,down_y:0,last_x:0,last_y:0};this.touchAttrs={last1:{x:0,y:0},last2:{x:0,y:0}};
this.imageInfo=null;this.ctrEl=QU.id(a);QU.elClear(this.ctrEl);QU.elSetClass(this.ctrEl,"imageviewer",true);
this.canvas=document.createElement("canvas");this.canvas.width=1;this.canvas.height=1;this.canvas.unselectable="on";
QU.elSetStyles(this.canvas,{WebkitUserSelect:"none",MozUserSelect:"none",OUserSelect:"none",msUserSelect:"none",userSelect:"none",WebkitTapHighlightColor:"rgba(0,0,0,0)",WebkitTouchCallout:"none"});
this.ctrEl.appendChild(this.canvas);this.layout();this.canvasContext=this.canvas.getContext("2d");if(!this.options.quality){this.canvas.style.msInterpolationMode="nearest-neighbor";
this.canvas.style.imageRendering="-webkit-optimize-contrast";if(this.canvasContext.mozImageSmoothingEnabled!==undefined){this.canvasContext.mozImageSmoothingEnabled=false;
}}this.content=new ImgGrid(this.canvas.width,this.canvas.height,c,this.options.stripaligns,this.canvasContext,this.options.animation,this.options.maxtiles,function(e){this.onContentReady(e);
}.bind(this));this.imageSrc=this.content.urlParams.src;this.imageServer=this.content.urlBase;if(this.options.showcontrols!="no"){this.createControls();
}}ImgCanvasView.prototype.destroy=function(){this.events=null;this.content.destroy();this.content=null;
this.removeEvents();QU.elRemove(this.canvas);this.canvas=null;this.canvasContext=null;};ImgCanvasView.prototype.init=function(){this.removeEvents();
this.addEvents();};ImgCanvasView.prototype.addEvents=function(){try{this._events.touchstart=function(b){this.onTouchStart(b);
}.bind(this);this._events.touchmove=function(b){this.onTouchMove(b);}.bind(this);this._events.touchend=function(b){this.onTouchEnd(b);
}.bind(this);this._events.touchcancel=function(b){this.onTouchCancel(b);}.bind(this);this.canvas.addEventListener("touchstart",this._events.touchstart,false);
this.canvas.addEventListener("touchmove",this._events.touchmove,false);this.canvas.addEventListener("touchend",this._events.touchend,false);
this.canvas.addEventListener("touchcancel",this._events.touchcancel,false);}catch(a){}try{this._events.mousedown=function(b){this.onMouseDown(b);
}.bind(this);this._events.mousemove=function(b){this.onMouseMove(b);}.bind(this);this._events.mouseup=function(b){this.onMouseUp(b);
}.bind(this);this._events.mouseleave=function(b){this.onMouseUp(b);}.bind(this);this.canvas.addEventListener("mousedown",this._events.mousedown,false);
this.canvas.addEventListener("mousemove",this._events.mousemove,false);this.canvas.addEventListener("mouseup",this._events.mouseup,false);
this.canvas.addEventListener("mouseleave",this._events.mouseleave,false);}catch(a){}this._events.selectstart=function(b){return false;
};this._events.dragstart=function(b){return false;};this.canvas.addEventListener("selectstart",this._events.selectstart,false);
this.canvas.addEventListener("dragstart",this._events.dragstart,false);};ImgCanvasView.prototype.removeEvents=function(){for(var a in this._events){this.canvas.removeEventListener(a,this._events[a],false);
}this._events={};};ImgCanvasView.prototype.layout=function(){if(!this.canvas){return;}this.ctrOuterPos=QU.elOuterPosition(this.ctrEl);
this.ctrInnerPos=QU.elInnerSize(this.ctrEl,false);var a=QU.elInnerOffsets(this.ctrEl);this.ctrInnerPos.offsetLeft=a.left;
this.ctrInnerPos.offsetTop=a.top;this.canvas.width=this.ctrInnerPos.width;this.canvas.height=this.ctrInnerPos.height;
if(this.content){this.content.setViewportSize(this.canvas.width,this.canvas.height);}};ImgCanvasView.prototype.reset=function(){if(!this.content){return;
}this.content.reset();this.refreshZoomControls();};ImgCanvasView.prototype.onMouseDown=function(a){if(a.button==0){if((a.api_event==undefined)&&this.options.doubleclickreset&&(Date.now()-this.mouseAttrs.downTime<300)){this.reset();
}else{var b=QU.evPosition(a);this.mouseAttrs.down=true;this.mouseAttrs.downTime=Date.now();this.mouseAttrs.down_x=this.mouseAttrs.last_x=b.page.x;
this.mouseAttrs.down_y=this.mouseAttrs.last_y=b.page.y;this.mouseAttrs.dragged=false;QU.elSetClass(this.canvas,"panning",true);
}}};ImgCanvasView.prototype.onMouseMove=function(a){if(this.mouseAttrs.down){this.mouseAttrs.dragged=true;
if(this.content&&this.content.initialised&&!this.content.animating){setTimeout(function(){var d=QU.evPosition(a);
var c=(d.page.x-this.mouseAttrs.down_x);var b=(d.page.y-this.mouseAttrs.down_y);this.content.panGrid(c,b,true,true);
this.mouseAttrs.last_x=this.mouseAttrs.down_x;this.mouseAttrs.last_y=this.mouseAttrs.down_y;this.mouseAttrs.down_x=d.page.x;
this.mouseAttrs.down_y=d.page.y;}.bind(this),1);}}};ImgCanvasView.prototype.onMouseUp=function(d){if(this.mouseAttrs.down){this.mouseAttrs.down=false;
QU.elSetClass(this.canvas,"panning",false);if(!this.mouseAttrs.dragged&&this.uiAttrs.fullScreen&&this.options.fullScreenCloseOnClick){var c=this.getClickPosition(d,true);
if(c.x<0||c.x>1||c.y<0||c.y>1){this.toggleFullscreen();return;}}if(this.content&&this.content.initialised&&!this.content.animating){if(!this.mouseAttrs.dragged){var c=this.getClickPosition(d,true);
this.content.zoomGrid((d.shiftKey?-1:1),c);this.refreshZoomControls();}else{var f=QU.evPosition(d);var b=(f.page.x-this.mouseAttrs.last_x);
var a=(f.page.y-this.mouseAttrs.last_y);if(Math.abs(b)>3||Math.abs(a)>3){this.content.autoPanGrid(b,a);
}}}}};ImgCanvasView.prototype.onTouchStart=function(a){a.preventDefault();if(a.touches.length==1){this.onMouseDown({type:"mousedown",pageX:a.touches[0].pageX,pageY:a.touches[0].pageY,button:0});
}this.touchPosReset();};ImgCanvasView.prototype.onTouchMove=function(h){h.preventDefault();if(h.touches.length==1){this.onMouseMove({type:"mousemove",pageX:h.touches[0].pageX,pageY:h.touches[0].pageY});
}else{if(h.touches.length==2){this.mouseAttrs.downTime=0;if((this.touchAttrs.last1.x!=0)||(this.touchAttrs.last1.y!=0)||(this.touchAttrs.last2.x!=0)||(this.touchAttrs.last2.y!=0)){var i=Math.abs(this.touchAttrs.last1.x-this.touchAttrs.last2.x),d=Math.abs(this.touchAttrs.last1.y-this.touchAttrs.last2.y),g=Math.sqrt((i*i)+(d*d)),j=Math.abs(h.touches[0].pageX-h.touches[1].pageX),f=Math.abs(h.touches[0].pageY-h.touches[1].pageY),k=Math.sqrt((j*j)+(f*f)),c=(k>g),a=(Math.abs(k-g)>20);
if(a){var b={type:"mousedown",pageX:Math.round(this.touchAttrs.last1.x+((this.touchAttrs.last2.x-this.touchAttrs.last1.x)/2)),pageY:Math.round(this.touchAttrs.last1.y+((this.touchAttrs.last2.y-this.touchAttrs.last1.y)/2)),button:0,shiftKey:!c,api_event:true};
this.onMouseDown(b);this.onMouseUp(b);this.touchPosReset();}}else{this.touchAttrs={last1:{x:h.touches[0].pageX,y:h.touches[0].pageY},last2:{x:h.touches[1].pageX,y:h.touches[1].pageY}};
}}}};ImgCanvasView.prototype.onTouchEnd=function(a){a.preventDefault();this.onMouseUp({type:"mouseup",pageX:a.changedTouches[0].pageX,pageY:a.changedTouches[0].pageY,shiftKey:false});
this.touchPosReset();};ImgCanvasView.prototype.onTouchCancel=function(a){this.onMouseUp({type:"mouseup",pageX:a.changedTouches[0].pageX,pageY:a.changedTouches[0].pageY,shiftKey:false});
this.touchPosReset();};ImgCanvasView.prototype.touchPosReset=function(){this.touchAttrs={last1:{x:0,y:0},last2:{x:0,y:0}};
};ImgCanvasView.prototype.onContentReady=function(a){if(!this.content){return;}if(this.options.title!=null){a.title=this.options.title;
}if(this.options.description!=null){a.description=this.options.description;}this.imageInfo=a;this.setImageTitle(a.title);
this.enableDownload(a.download);this.refreshZoomControls();if(this.uiAttrs.fullScreen){this.autoZoomFit();
}if(this.events){ImgUtils.fireEvent(this.events.onload,this,[this.imageSrc]);}};ImgCanvasView.prototype.autoZoomFit=function(){if(this.content&&this.content.initialised){this.content.zoomFit();
this.refreshZoomControls();}};ImgCanvasView.prototype.autoZoom=function(d){var b={type:"mousedown",pageX:Math.round(this.ctrOuterPos.x+this.ctrInnerPos.offsetLeft+(this.canvas.width/2)),pageY:Math.round(this.ctrOuterPos.y+this.ctrInnerPos.offsetTop+(this.canvas.height/2)),button:0,shiftKey:!d,api_event:true};
var c=this.getFixedContainer();if(c){b.pageX+=window.pageXOffset;b.pageY+=window.pageYOffset;if(c!==this.ctrEl){var a=QU.elOuterPosition(c);
b.pageX+=a.x;b.pageY+=a.y;}}this.onMouseDown(b);this.onMouseUp(b);};ImgCanvasView.prototype.stripTags=function(c,a){a=a||"";
var b=new RegExp("</?"+a+"([^>]+)?>","gi");return c.replace(b," ");};ImgCanvasView.prototype.getViewportPosition=function(){var c=-this.content.g2d.origin.x,b=-this.content.g2d.origin.y,d=this.canvas.width,a=this.canvas.height;
return{left:Math.round8(c/this.content.grid.width),top:Math.round8(b/this.content.grid.height),right:Math.round8((c+d)/this.content.grid.width),bottom:Math.round8((b+a)/this.content.grid.height)};
};ImgCanvasView.prototype.getFixedContainer=function(){var b,a=this.ctrEl;while(a){b=QU.elGetStyles(a,["position"]);
if(b.position==="fixed"){return a;}a=a.parentNode;}return null;};ImgCanvasView.prototype.getClickPosition=function(a,g){var h=QU.evPosition(a);
var d=h.page.x-this.ctrOuterPos.x;var c=h.page.y-this.ctrOuterPos.y;var f=this.getFixedContainer();if(f){d-=window.pageXOffset;
c-=window.pageYOffset;if(f!==this.ctrEl){var i=QU.elOuterPosition(f);d-=i.x;c-=i.y;}}d-=this.ctrInnerPos.offsetLeft;
c-=this.ctrInnerPos.offsetTop;var b={x:Math.round8(d/this.canvas.width),y:Math.round8(c/this.canvas.height)};
if(g){var e=this.getViewportPosition();return{x:Math.round8(e.left+((e.right-e.left)*b.x)),y:Math.round8(e.top+((e.bottom-e.top)*b.y))};
}else{return b;}};ImgCanvasView.prototype.createControls=function(){var l;if(this.options.showcontrols=="auto"){l=document.createElement("div");
l.className="controltoggle panelbg";l.innerHTML="&nbsp;";l.style.position="relative";l.addEventListener("mousedown",this.toggleControls.bind(this),false);
this.ctrEl.appendChild(l);}var m=document.createElement("div");QU.elSetStyles(m,{position:"relative",width:"100%",lineHeight:"normal",overflow:"hidden",textAlign:"center",cursor:"default"});
m.addEventListener("click",function(i){if(this.uiAttrs.fullScreen&&this.options.fullScreenCloseOnClick){this.toggleFullscreen();
}}.bind(this),false);var n=document.createElement("span");n.className="controlpanel panelbg"+((this.options.showcontrols=="auto")?" up":"");
n.addEventListener("click",function(i){i.stopPropagation();},false);m.appendChild(n);if(this.options.controls.title){var e=document.createElement("span");
e.className="controltitle";e.innerHTML="Loading...";n.appendChild(e);}if(this.options.controls.download){var h=document.createElement("span");
h.className="icon download disabled";h.title="Download";h.innerHTML="&nbsp;";h.addEventListener("mousedown",this.downloadImage.bind(this),false);
n.appendChild(h);var j=document.createElement("span");j.className="separator";j.innerHTML="&nbsp;";n.appendChild(j);
}if(this.options.controls.help){var a=document.createElement("span");a.className="icon help";a.title="Help";
a.innerHTML="&nbsp;";a.addEventListener("mousedown",this.toggleHelp.bind(this),false);n.appendChild(a);
}if(this.options.controls.reset){var f=document.createElement("span");f.className="icon reset";f.title="Reset zoom";
f.innerHTML="&nbsp;";f.addEventListener("mousedown",this.reset.bind(this),false);n.appendChild(f);}if(this.options.controls.zoomin){var k=document.createElement("span");
k.className="icon zoomin";k.title="Zoom in";k.innerHTML="&nbsp;";k.addEventListener("mousedown",function(){this.autoZoom(true);
}.bind(this),false);n.appendChild(k);}if(this.options.controls.zoomout){var d=document.createElement("span");
d.className="icon zoomout";d.title="Zoom out";d.innerHTML="&nbsp;";d.addEventListener("mousedown",function(){this.autoZoom(false);
}.bind(this),false);n.appendChild(d);}if(this.options.controls.fullscreen){var c=document.createElement("span");
c.className="icon fulltoggle";c.title="Toggle full screen mode";c.innerHTML="&nbsp;";c.addEventListener("mousedown",this.toggleFullscreen.bind(this),false);
n.appendChild(c);}this.controlpanel=n;this.ctrEl.appendChild(m);var o=this.controlpanel.querySelectorAll(".icon");
for(var g=0;g<o.length;g++){var b=o[g];b.addEventListener("mouseover",function(){QU.elSetClass(this,"rollover",true);
}.bind(b),false);b.addEventListener("mouseout",function(){QU.elSetClass(this,"rollover",false);}.bind(b),false);
}};ImgCanvasView.prototype.clearRollovers=function(){if(this.controlpanel){var b=this.controlpanel.querySelectorAll(".icon");
for(var a=0;a<b.length;a++){QU.elSetClass(b[a],"rollover",false);}}};ImgCanvasView.prototype.refreshZoomControls=function(){if(this.content&&this.content.initialised&&this.controlpanel){var e=this.controlpanel.querySelector(".zoomin"),a=this.controlpanel.querySelector(".zoomout"),d=this.controlpanel.querySelector(".reset"),c=(this.content.zoom.nextLevel<this.content.zoom.maxLevel),b=(this.content.zoom.nextLevel>1),f=b;
if(e){QU.elSetClass(e,"disabled",!c);}if(a){QU.elSetClass(a,"disabled",!b);}if(d){QU.elSetClass(d,"disabled",!f);
}}};ImgCanvasView.prototype.enableDownload=function(b){if(this.controlpanel){var a=this.controlpanel.querySelector(".download");
if(a){QU.elSetClass(a,"disabled",!b);a.title=(b?"Download full image":"Image download not permitted");
}}};ImgCanvasView.prototype.setImageTitle=function(c){if(this.controlpanel){var a=this.controlpanel.querySelector(".controltitle");
if(a){var d=24,e=this.stripTags(c);if(e.length>d){var b=e.indexOf(" ",d-5);if((b==-1)||(b>d)){b=e.indexOf(".",d-5);
}if((b==-1)||(b>d)){b=e.indexOf(",",d-5);}if((b==-1)||(b>d)){b=e.indexOf(";",d-5);}if((b==-1)||(b>d)){b=e.indexOf("-",d-5);
}if((b==-1)||(b>d)){b=e.indexOf("\n",d-5);}if((b==-1)||(b>d)){b=d;}e=e.substring(0,b)+"...";}a.innerHTML=e;
if(!a._onclick){a._onclick=this.toggleImageInfo.bind(this);a.addEventListener("click",a._onclick,false);
}}}};ImgCanvasView.prototype.toggleControls=function(){if(this.controlpanel){this.clearRollovers();this.refreshZoomControls();
var b=QU.elHasClass(this.controlpanel,"up");QU.elSetClass(this.controlpanel,"up",!b);var a=this.ctrEl.querySelector(".controltoggle");
if(a){QU.elSetClass(a,"up",b);}}};ImgCanvasView.prototype.downloadImage=function(){if(this.imageInfo&&this.imageInfo.download){if(this.events){ImgUtils.fireEvent(this.events.ondownload,this,[this.imageSrc]);
}window.location.href=this.imageServer+"/original?src="+encodeURIComponent(this.imageSrc)+"&attach=1";
}};ImgCanvasView.prototype.toggleAlert=function(f){if(this.uiAttrs.alertVisible){QU.elRemove(this.uiAttrs.alertEl);
this.uiAttrs.alertEl=null;this.uiAttrs.alertVisible=false;}else{f=f.replace(/\r\n?/g,"\n");f=f.replace(/\n/g,"<br/>");
var e=document.createElement("div");QU.elSetStyles(e,{position:"absolute",width:"0px",height:"0px",zIndex:"1102"});
this.uiAttrs.alertEl=e;var c=document.createElement("div");c.className="alertpanel panelbg";c.innerHTML=this.stripTags(f,"(?!br)");
QU.elSetStyles(c,{position:"absolute",zIndex:"1102",lineHeight:"normal",overflow:"auto",visibility:"hidden"});
c.addEventListener("mousedown",function(){this.toggleAlert();}.bind(this),false);c.addEventListener("touchmove",function(){return false;
},false);this.uiAttrs.alertEl.appendChild(c);this.ctrEl.insertBefore(this.uiAttrs.alertEl,this.ctrEl.firstChild);
c.style.left=Math.round((this.canvas.width-c.offsetWidth)/2)+"px";c.style.top=Math.max(0,Math.round((this.canvas.height-c.offsetHeight)/2))+"px";
if(c.offsetHeight>this.ctrInnerPos.height){var d=QU.elInnerOffsets(c),b=(d.top+d.bottom),a=Math.max(20,(this.ctrInnerPos.height-b));
c.style.height=a+"px";}c.style.visibility="visible";this.uiAttrs.alertVisible=true;}};ImgCanvasView.prototype.toggleHelp=function(){var a="Desktop users: &nbsp;Click to zoom in, shift-click to zoom out, click and hold to pan the image"+(this.options.doubleclickreset?", and double-click to reset the zoom.":".")+"<br/><br/>Tablet users: &nbsp;Tap to zoom in, or pinch with 2 fingers to zoom in and out, tap and hold to pan the image"+(this.options.doubleclickreset?", and tap twice to reset the zoom.":".");
this.toggleAlert(a);};ImgCanvasView.prototype.toggleImageInfo=function(){if(this.imageInfo){var a=this.imageInfo.title;
if((this.imageInfo.title.length>0)&&(this.imageInfo.description.length>0)){a+="<br/><br/>";}a+=this.imageInfo.description;
}else{var a="No information available";}this.toggleAlert(a);if(this.events&&this.uiAttrs.alertVisible){ImgUtils.fireEvent(this.events.oninfo,this,[this.imageSrc]);
}};ImgCanvasView.prototype.toggleFullscreen=function(){if(this.uiAttrs.animating){return;}if(this.content.animating){return;
}if(this.uiAttrs.alertVisible){this.toggleAlert();}if(this.uiAttrs.fullResizeFn==null){this.uiAttrs.fullKeydownFn=function(b){this.fullscreenKeydown(b);
}.bind(this);this.uiAttrs.fullResizeFn=function(b){this.fullscreenResize();}.bind(this);}if(!this.uiAttrs.fader){this.uiAttrs.fader=new ElementFader(this.ctrEl,300);
}if(this.uiAttrs.fullScreen){this.uiAttrs.animating=true;this.uiAttrs.fader.fadeOut(function(){window.removeEventListener("resize",this.uiAttrs.fullResizeFn,false);
window.removeEventListener("keydown",this.uiAttrs.fullKeydownFn,false);this.uiAttrs.fullCloseEl.removeEventListener("click",this.uiAttrs.fullCloseEl._onclick,false);
QU.elRemove(this.uiAttrs.fullCloseEl);this.uiAttrs.fullCloseEl=null;QU.elRemove(this.ctrEl);QU.elSetStyles(this.ctrEl,this.uiAttrs.containerStyles);
QU.elSetClass(this.ctrEl,"fullscreen",false);this.uiAttrs.fullSwapEl.parentNode.replaceChild(this.ctrEl,this.uiAttrs.fullSwapEl);
this.uiAttrs.fullSwapEl=null;this.uiAttrs.fullMaskEl.destroy();this.uiAttrs.fullMaskEl=null;this.layout();
this.clearRollovers();this.reset();this.uiAttrs.animating=false;this.uiAttrs.fullScreen=false;if(this.events){ImgUtils.fireEvent(this.events.onfullscreen,this,[this.imageSrc,false]);
}}.bind(this));}else{var a=this.fullscreenGetCoords();this.uiAttrs.containerStyles=QU.elGetStyles(this.ctrEl,["position","zIndex","opacity","left","top","width","height","margin"]);
this.uiAttrs.fullMaskEl=new PageMask("fullscreen_mask",{zIndex:"1100"},function(b){this.toggleFullscreen();
}.bind(this));this.uiAttrs.fullMaskEl.show();this.uiAttrs.fullSwapEl=this.ctrEl.cloneNode(false);this.ctrEl.parentNode.replaceChild(this.uiAttrs.fullSwapEl,this.ctrEl);
QU.elSetStyles(this.ctrEl,{position:this.options.fullScreenFixed?"fixed":"absolute",zIndex:"1101",opacity:"0",left:a.left+"px",top:a.top+"px",width:a.width+"px",height:a.height+"px",margin:"0"});
QU.elSetClass(this.ctrEl,"fullscreen",true);document.body.insertBefore(this.ctrEl,document.body.firstChild);
this.layout();this.clearRollovers();this.uiAttrs.fullCloseEl=document.createElement("a");this.uiAttrs.fullCloseEl.className="close_button";
QU.elSetStyles(this.uiAttrs.fullCloseEl,{display:"block",position:"absolute",zIndex:"1102",top:"0px",right:"0px",width:"33px",height:"32px"});
this.uiAttrs.fullCloseEl._onclick=this.toggleFullscreen.bind(this);this.uiAttrs.fullCloseEl.addEventListener("click",this.uiAttrs.fullCloseEl._onclick,false);
this.ctrEl.insertBefore(this.uiAttrs.fullCloseEl,this.ctrEl.firstChild);window.addEventListener("keydown",this.uiAttrs.fullKeydownFn,false);
window.addEventListener("resize",this.uiAttrs.fullResizeFn,false);this.uiAttrs.fader.fadeIn(this.autoZoomFit.bind(this));
this.uiAttrs.fullScreen=true;if(this.events){ImgUtils.fireEvent(this.events.onfullscreen,this,[this.imageSrc,true]);
}}};ImgCanvasView.prototype.fullscreenGetCoords=function(){var c=window.innerWidth?{x:window.innerWidth,y:window.innerHeight}:{x:document.body.clientWidth,y:document.body.clientHeight},a=this.options.fullScreenFixed?{x:0,y:0}:{x:window.pageXOffset,y:window.pageYOffset},f=Math.min(Math.round(c.x/40),Math.round(c.y/40));
var d=(a.x+f),e=(a.y+f),b=(c.x-((2*f)+(this.ctrOuterPos.width-this.ctrInnerPos.width))),g=(c.y-((2*f)+(this.ctrOuterPos.height-this.ctrInnerPos.height)));
if(this.controlpanel){if(f<this.controlpanel.offsetHeight){g-=(this.controlpanel.offsetHeight-f);}}return{left:d,top:e,width:Math.max(b,100),height:Math.max(g,100)};
};ImgCanvasView.prototype.fullscreenKeydown=function(b){var a=(b.which||b.keyCode);if(a===27){setTimeout(this.toggleFullscreen.bind(this),1);
}};ImgCanvasView.prototype.fullscreenResize=function(){var a=this.fullscreenGetCoords();this.ctrEl.style.left=a.left+"px";
this.ctrEl.style.top=a.top+"px";this.ctrEl.style.width=a.width+"px";this.ctrEl.style.height=a.height+"px";
this.layout();};function ElementFader(a,b){this.element=a;this.steps=Math.round(Math.max(1,b/16.66));
this.increment=1/this.steps;this.stepFn=this._step.bind(this);if(window.requestAnimationFrame){this.animate=function(){window.requestAnimationFrame(this.stepFn);
};}else{this.animate=function(){return setTimeout(this.stepFn,17);};}}ElementFader.prototype.fadeIn=function(a){this.onCompleteFn=a;
this.step=0;this.opacity=0;this.direction=1;this.animate();};ElementFader.prototype.fadeOut=function(a){this.onCompleteFn=a;
this.step=0;this.opacity=1;this.direction=-1;this.animate();};ElementFader.prototype.destroy=function(){this.element=null;
this.stepFn=function(){};this.animate=function(){};};ElementFader.prototype._step=function(){this.opacity+=(this.increment*this.direction);
this.element.style.opacity=this.opacity;this.step++;if(this.step<this.steps){this.animate();}else{if(this.onCompleteFn){this.onCompleteFn();
}}};function ElementScroller(b,c,a){this.element=b;this.steps=Math.round(Math.max(1,c/16.66));this.easeFn=a;
this.stepFn=this._step.bind(this);if(window.requestAnimationFrame){this.animate=function(){window.requestAnimationFrame(this.stepFn);
};}else{this.animate=function(){return setTimeout(this.stepFn,17);};}}ElementScroller.prototype.scrollTo=function(a,b){this.startX=this.element.scrollLeft;
this.startY=this.element.scrollTop;this.dx=(a-this.startX);this.dy=(b-this.startY);this.step=0;this.animate();
};ElementScroller.prototype.destroy=function(){this.element=null;this.stepFn=function(){};this.animate=function(){};
};ElementScroller.prototype._step=function(){this.step++;this.element.scrollLeft=this.easeFn(this.step,this.startX,this.dx,this.steps);
this.element.scrollTop=this.easeFn(this.step,this.startY,this.dy,this.steps);if(this.step<this.steps){this.animate();
}};function PageMask(c,d,a){this.element=document.createElement("div");this.element.style.position="fixed";
this.element.style.left="0px";this.element.style.top="0px";this.element.style.width="100vw";this.element.style.height="100vh";
if(c){this.element.className=c;}if(d){for(var b in d){this.element.style[b]=d[b];}}if(a){this._onclick=function(f){a(this);
}.bind(this);this.element.addEventListener("click",this._onclick,false);}if(!c&&!d){this.element.style.backgroundColor="#000000";
this.element.style.opacity="0.8";}this.element.style.display="none";if(document.body.firstChild){document.body.insertBefore(this.element,document.body.firstChild);
}else{document.body.appendChild(this.element);}}PageMask.prototype.show=function(){this.element.style.display="block";
};PageMask.prototype.hide=function(){this.element.style.display="none";};PageMask.prototype.destroy=function(){this.hide();
if(this._onclick){this.element.removeEventListener("click",this._onclick,false);}this.element.parentNode.removeChild(this.element);
};ImgUtils={};ImgUtils.fireEvent=function(c,a,b){if(c&&typeof c==="function"){setTimeout(function(){c.apply(this,b);
}.bind(a),1);}};ImgUtils.getImageSrc=function(a){if(a.src){return a.src;}var b=a.style.backgroundImage;
if(b&&(b.length>5)&&(b.indexOf("url(")===0)){b=b.substring(4);if((b.charAt(0)=="'")||(b.charAt(0)=='"')){return b.substring(1,b.length-2);
}else{return b.substring(0,b.length-1);}}return null;};function _img_fs_zoom_click(e,b,d){var c=ImgUtils.getImageSrc(e);
if(!c){return;}var a=QU.id("_cv_fs_zoom_click_el");if(!a){a=document.createElement("div");a.id="_cv_fs_zoom_click_el";
QU.elSetStyles(a,{position:"absolute",display:"block",width:"500px",height:"500px",left:"-1000px"});document.body.insertBefore(a,document.body.firstChild);
}canvas_view_init(a,c,b,d);canvas_view_toggle_fullscreen(a);}function _get_ct_viewer(a){a=QU.id(a);return(a&&a._cv_viewer)?a._cv_viewer:null;
}function haveCanvasSupport(){if(window._hcvs===undefined){var a=document.createElement("canvas");window._hcvs=!!(a&&a.getContext);
}return window._hcvs;}function canvas_view_init(a,d,b,c){a=QU.id(a);if(a){if(haveCanvasSupport()&&QU.supported){if(a._cv_viewer!=undefined){a._cv_viewer.destroy();
}var e=new ImgCanvasView(a,d,b,c);e.init();a._cv_viewer=e;}else{a.innerHTML="Sorry, this control is unsupported. Try upgrading your web browser.";
}}return false;}function canvas_view_zoom_in(a){var b=_get_ct_viewer(a);if(b){b.autoZoom(true);}return false;
}function canvas_view_zoom_out(a){var b=_get_ct_viewer(a);if(b){b.autoZoom(false);}return false;}function canvas_view_toggle_help(a){var b=_get_ct_viewer(a);
if(b){b.toggleHelp();}return false;}function canvas_view_toggle_image_info(a){var b=_get_ct_viewer(a);
if(b){b.toggleImageInfo();}return false;}function canvas_view_toggle_fullscreen(a){var b=_get_ct_viewer(a);
if(b){b.toggleFullscreen();}return false;}function canvas_view_reset(a){var b=_get_ct_viewer(a);if(b){b.reset();
}return false;}function canvas_view_resize(a){var b=_get_ct_viewer(a);if(b){b.layout();}return false;
}function canvas_view_init_image(e,b,c){e=QU.id(e);if(e){var d=b?QU.clone(b):{};var a=e.title||e.alt;
if(a){if(d.title==undefined){d.title=a;}}if(d.stripaligns===undefined){d.stripaligns=true;}if(e._onclick){e.removeEventListener("click",e._onclick,false);
}e._onclick=function(){_img_fs_zoom_click(e,d,c);};e.addEventListener("click",e._onclick,false);}return false;
}function canvas_view_init_all_images(e,b,d){var a=document.querySelectorAll("."+e);for(var c=0;c<a.length;
c++){canvas_view_init_image(a[c],b,d);}return false;}
/*!
    Document:      common_view.js
    Date started:  12 September 2017
    By:            Matt Fozard
    Purpose:       Quru Image Server viewer utilities and common routines
    Requires:
    Copyright:     Quru Ltd (www.quru.com)
    Licence:

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU Affero General Public License as published
    by the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU Affero General Public License for more details.

    You should have received a copy of the GNU Affero General Public License
    along with this program.  If not, see http://www.gnu.org/licenses/
*/
if(!window.QU){QU={version:1,supported:([].forEach!==undefined)&&([].indexOf!==undefined)&&((function(){}).bind!==undefined)&&(Object.keys!==undefined)&&(window.addEventListener!==undefined)&&(window.getComputedStyle!==undefined)&&(window.pageXOffset!==undefined)&&(window.JSON!==undefined)};
QU.id=function(a){if(typeof a==="number"){a=""+a;}if(typeof a==="string"){return document.getElementById(a);
}if(typeof a==="object"){return a;}return null;};QU.elClear=function(a){a=QU.id(a);while(a.firstChild){a.removeChild(a.firstChild);
}return a;};QU.elRemove=function(a){a=QU.id(a);if(a&&a.parentNode){a.parentNode.removeChild(a);}return a;
};QU.elOuterPosition=function(c){c=QU.id(c);var d=c,a=0,b=0;if(d.offsetParent){do{a+=d.offsetLeft;b+=d.offsetTop;
}while(d=d.offsetParent);}return{x:a,y:b,width:c.offsetWidth,height:c.offsetHeight};};QU.elInnerSize=function(c,a){c=QU.id(c);
var d={width:c.clientWidth,height:c.clientHeight};if(!a){var b=window.getComputedStyle(c);d.width-=Math.round(parseFloat(b.paddingLeft)+parseFloat(b.paddingRight));
d.height-=Math.round(parseFloat(b.paddingTop)+parseFloat(b.paddingBottom));d.width=Math.max(d.width,0);
d.height=Math.max(d.height,0);}return d;};QU.elInnerOffsets=function(b){b=QU.id(b);var a=window.getComputedStyle(b);
return{left:Math.round(parseFloat(a.paddingLeft)+parseFloat(a.borderLeftWidth)),right:Math.round(parseFloat(a.paddingRight)+parseFloat(a.borderRightWidth)),top:Math.round(parseFloat(a.paddingTop)+parseFloat(a.borderTopWidth)),bottom:Math.round(parseFloat(a.paddingBottom)+parseFloat(a.borderBottomWidth))};
};QU.elSetClass=function(d,c,e){d=QU.id(d);if(d.classList){if(e){d.classList.add(c);}else{d.classList.remove(c);
}}else{var b=d.className.split(" "),a=b.indexOf(c);if(b.length===1&&b[0]===""){b.length=0;}if(e&&(a===-1)){b.push(c);
}else{if(!e&&(a!==-1)){b.splice(a,1);}}d.className=b.join(" ");}return d;};QU.elHasClass=function(c,b){c=QU.id(c);
if(c.classList){return c.classList.contains(b);}else{var a=c.className.split(" ");return a.indexOf(b)!==-1;
}};QU.elGetStyles=function(c,g){c=QU.id(c);var b,f={};if(g){try{b=window.getComputedStyle(c);}catch(d){}if(b){for(var a=0;
a<g.length;a++){f[g[a]]=b[g[a]];}}}return f;};QU.elSetStyles=function(b,c){b=QU.id(b);if(c){for(var a in c){b.style[a]=c[a];
}}return b;};QU.evPosition=function(b){var c={x:0,y:0},a={x:0,y:0};if(b.type.indexOf("touch")==0||b.type.indexOf("gesture")==0){if(b.touches&&b.touches[0]){var e=b.touches[0];
c.x=e.pageX;c.y=e.pageY;a.x=e.clientX;a.y=e.clientY;}}else{var d=document.documentElement||document.body;
c.x=(b.pageX!=null)?b.pageX:b.clientX+d.scrollLeft;c.y=(b.pageY!=null)?b.pageY:b.clientY+d.scrollTop;
a.x=(b.pageX!=null)?b.pageX-window.pageXOffset:b.clientX;a.y=(b.pageY!=null)?b.pageY-window.pageYOffset:b.clientY;
}return{page:c,viewport:a};};QU.jsonRequest=function(b,e,a,d){var c=new XMLHttpRequest();if("withCredentials" in c){c.open(e,b,true);
c.setRequestHeader("Accept","application/json");}else{if(typeof XDomainRequest!=="undefined"){c=new XDomainRequest();
c._XDR=true;c.onprogress=function(){};c.ontimeout=function(){};c.open(e,b);}else{return null;}}c.onload=function(){if(!c._XDR&&(c.status<200||c.status>=400)){if(d){d(c,c.responseText);
}return;}if(a){var g;try{g=JSON.parse(c.responseText);}catch(f){if(d){d(c,"Invalid JSON: "+f);}return;
}a(c,g);}};c.onerror=function(){if(d){d(c,c.responseText);}};return c;};QU.splitURL=function(d){var a,c,b,e={protocol:"",server:"",path:"",query:"",fragment:""};
a=d.indexOf("//");if(a!==-1){e.protocol=d.substring(0,a+2);d=d.substring(a+2);}a=d.indexOf("/");if(a>=1){e.server=d.substring(0,a);
d=d.substring(a);}c=d.indexOf("?");if(c!==-1){e.path=d.substring(0,c);e.query=d.substring(c+1);b=e.query.indexOf("#");
if(b!==-1){e.fragment=e.query.substring(b+1);e.query=e.query.substring(0,b);}}else{e.path=d;b=e.path.indexOf("#");
if(b!==-1){e.fragment=e.path.substring(b+1);e.path=e.path.substring(0,b);}}return e;};QU.ObjectToQueryString=function(a,c){var d=[];
var b=Object.keys(a);b.forEach(function(g){var h=a[g],f;if(c){g=c+"["+g+"]";}switch(typeof h){case"object":f=QU.ObjectToQueryString(h,g);
break;case"array":var e={};h.forEach(function(k,j){e[j]=k;});f=QU.ObjectToQueryString(e,g);break;default:f=g+"="+encodeURIComponent(h);
}if(h!=null){d.push(f);}});return d.join("&");};QU.QueryStringToObject=function(g,d){if(d===undefined){d=true;
}var a=function(h){return decodeURIComponent(h.replace(/\+/g," "));};var f=true,b=true;var e=g.split(/[&;]/),c={};
if(!e.length){return c;}e.forEach(function(l){var h=l.indexOf("=")+1,j=h?l.substr(h):"",i=h?l.substr(0,h-1).match(/([^\]\[]+|(\B)(?=\]))/g):[l],k=c;
if(!i){return;}if(!d&&!j){return;}if(b){j=a(j);}i.forEach(function(n,m){if(f){n=a(n);}var o=k[n];if(m<i.length-1){k=k[n]=o||{};
}else{if(typeof o==="array"){o.push(j);}else{k[n]=o!=null?[o,j]:j;}}});});return c;};QU.whenReady=function(a){if(document.attachEvent?document.readyState==="complete":document.readyState!=="loading"){a();
}else{document.addEventListener("DOMContentLoaded",a);}};QU.clone=function(a){if((a===null)||(a===undefined)){return a;
}return JSON.parse(JSON.stringify(a));};QU.merge=function(f,e){var d=function(h,i,j){switch(typeof j){case"object":if(typeof h[i]=="object"){QU.merge(h[i],j);
}else{h[i]=QU.clone(j);}break;case"array":h[i]=QU.clone(j);break;default:h[i]=j;}return h;};for(var c=1,a=arguments.length;
c<a;c++){var g=arguments[c];if((g!==null)&&(g!==undefined)){for(var b in g){d(f,b,g[b]);}}}return f;};
}